> For the complete documentation index, see [llms.txt](https://docs.caf.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.caf.io/caf-sdk/android/standalone-modules/cafsmartauth/builder.md).

# Building the SDK

## Creating a CafSmartAuth SDK instance

In order to create a `CafSmartAuth` instance, you need to use the `CafBuilder` class. This class provides a set of methods to configure the SDK instance.

### Builder Properties

| Property      | Type    | Description                            | Required |
| ------------- | ------- | -------------------------------------- | :------: |
| `mobileToken` | String  | Mobile token provided by the platform. |     ✅    |
| `context`     | Context | Context of the application.            |     ✅    |

### Builder Methods

| Method                         | Type                         | Description                                                                              | Required |
| ------------------------------ | ---------------------------- | ---------------------------------------------------------------------------------------- | :------: |
| `setStage`                     | CafStage                     | Defines the environment stage (e.g., PROD, BETA). Default is PROD.                       |     ❌    |
| `setEmailUrl`                  | String                       | Sets the email authentication URL. Must be HTTPS protocol.                               |     ❌    |
| `setPhoneUrl`                  | String                       | Sets the phone authentication URL. Must be HTTPS protocol.                               |     ❌    |
| `setFaceAuthenticatorSettings` | CafFaceAuthenticatorSettings | Sets the face liveness authentication settings.                                          |     ❌    |
| `setThemeConfigurator`         | CafTheme                     | Sets the theme configuration for the SDK. Customize appearance for light and dark modes. |     ❌    |

### Theme Configuration

To customize the appearance of the SDK, use the theme configurator methods. Two structures are used for theme configuration: `CafThemeConfigurator` and `CafTheme`.

#### CafThemeConfigurator

```kotlin
data class CafThemeConfigurator(
    val lightTheme: CafTheme = CafTheme(),
    val darkTheme: CafTheme = CafTheme(),
)
```

This structure allows you to define separate themes for light and dark modes. Each theme is defined by a CafTheme structure.

```kotlin
data class CafTheme(
    val backgroundColor: String = "#FFFFFF",
    val textColor: String = "#FF000000",
    val linkColor: String = "#004AF7",
    val boxBorderColor: String = "#004AF7",
    val boxBackgroundColor: String = "#0A004AF7",
    val boxTextColor: String = "#004AF7",
    val progressColor: String = "#004AF7",
)
```

This structure defines various appearance attributes for the SDK. You can customize colors for backgrounds, text, links, borders, and progress indicators by providing hex string values.

### Example

```kotlin
    private fun setupCafFaceLiveness() {
        smartAuth = CafSmartAuth.CafBuilder("myMFAToken", this)
            .setStage(CafStage.PROD)
            .setEmailUrl("myEmailUrl") // Not mandatory
            .setPhoneUrl("myPhoneUrl") // Not mandatory
            .setFaceAuthenticatorSettings(
                CafFaceAuthenticatorSettings(
                    "myFaceAuthToken",
                    false,
                    true,
                    CafFilterStyle.LINE_DRAWING
                )
            )
            .setThemeConfigurator(
                CafThemeConfigurator(
                    lightTheme = CafTheme(
                        backgroundColor = "#FFFFFF",
                        textColor = "#FF000000",
                    )
                    darkTheme = CafTheme(
                        backgroundColor = "#FF000000",
                        textColor = "#FFFFFF",
                    )
                )
            )
            .build()
    }
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.caf.io/caf-sdk/android/standalone-modules/cafsmartauth/builder.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
